
//+------------------------------------------------------------------
//|                                                                 |
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
 
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  LimeGreen
#property indicator_color2  Red
#property indicator_color3  DeepSkyBlue
#property indicator_color4  DeepSkyBlue
#property indicator_color5  PaleVioletRed
#property indicator_color6  PaleVioletRed
#property indicator_color7  Gray
#property indicator_width1  2
#property indicator_style2  STYLE_DASH
#property indicator_style4  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_style7  STYLE_DASH

//
//
//
//
//

extern string TimeFrame               = "Current Time Frame";
extern int    NdoPrice                = PRICE_CLOSE;
extern double EMAPeriod               = 35;
extern double SigMaPeriod             = 5;
extern int    Ma_Mode                 = MODE_SMMA;
extern int    NormPeriod              = 100;
extern double SmoothPhase             = 0;
extern bool   SmoothDouble            = false;
extern int    DzLookBackBars          = 70;
extern double DzStartBuyProbability1  = 0.10;
extern double DzStartBuyProbability2  = 0.25;
extern double DzStartSellProbability1 = 0.10;
extern double DzStartSellProbability2 = 0.25;
extern bool   Interpolate             = true;

extern string _                       = "Alerts Settings";
extern bool   alertsOn                = true;
extern bool   alertsOnDevMaCross      = true;
extern bool   alertsOnUpLevel1Cross   = false;
extern bool   alertsOnUpLevel2Cross   = false; 
extern bool   alertsOnDnLevel1Cross   = false;
extern bool   alertsOnDnLevel2Cross   = false;  
extern bool   alertsOnZeroLevelCross  = false;  
extern bool   alertsOnCurrent         = false;
extern bool   alertsMessage           = true;
extern bool   alertsSound             = true;
extern bool   alertsEmail             = false;

extern bool   arrowsVisible           = true;
extern string arrowsIdentifier        = "dz norm deviation Arrows1";
extern double arrowsDisplacement      = 1.0;
extern color  arrowsUpColor           = DeepSkyBlue;
extern color  arrowsDnColor           = Red;
extern bool   arrowsOnDevMaCross      = true;
extern bool   arrowsOnUpLevel1Cross   = false;
extern bool   arrowsOnUpLevel2Cross   = false; 
extern bool   arrowsOnDnLevel1Cross   = false;
extern bool   arrowsOnDnLevel2Cross   = false;  
extern bool   arrowsOnZeroLevelCross  = false;  

//
//
//
//
//

#import "dynamicZone.dll"
   double  dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

double ndo[];
double ndma[];
double bl1[];
double bl2[];
double sl1[];
double sl2[];
double zl1[];
double dos[];
double trends[][6];

#define _tma1 0
#define _tup1 1
#define _tup2 2
#define _tdn1 3
#define _tdn2 4
#define _tzl1 5

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
  
int init() 
{
   
   IndicatorBuffers(8);
      SetIndexBuffer(0,ndo);
      SetIndexBuffer(1,ndma);
      SetIndexBuffer(2,bl1);
      SetIndexBuffer(3,bl2);
      SetIndexBuffer(4,sl1);
      SetIndexBuffer(5,sl2);
      SetIndexBuffer(6,zl1);
      SetIndexBuffer(7,dos);
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" Dynamic double zone normalized deviation("+DoubleToStr(EMAPeriod,2)+","+DoubleToStr(SigMaPeriod,2)+")");
      
   return(0);
}

//
//
//
//
//

int deinit()
{  
   if (!calculateValue && arrowsVisible) deleteArrows();  
return(0); 
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1); 
           if (returnBars) { ndo[0] = MathMin(limit+1,Bars-1); return(0); }
           
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     if (ArrayRange(trends,0)!=Bars) {  ArrayResize(trends,Bars); }
       for(i=limit,r=Bars-i-1; i>=0; i--,r++)
       {
             dos[i] = iMA(NULL,0,1,0,MODE_SMA,NdoPrice,i) - iMA(NULL,0,EMAPeriod,0,MODE_EMA,NdoPrice,i);
      
             //
             //
             //
             //
             //
         
            double hi     = dos[ArrayMaximum(dos,NormPeriod,i)];
            double lo     = dos[ArrayMinimum(dos,NormPeriod,i)];
            if (hi!=lo)
                 ndo[i]   = iDSmooth(100*(dos[i]- lo)/(hi - lo),EMAPeriod,SmoothPhase,SmoothDouble,i,0);        
            else ndo[i]   = iDSmooth(0,                         EMAPeriod,SmoothPhase,SmoothDouble,i,0); 
            if (DzStartBuyProbability1  > 0) bl1[i] = dzBuyP (ndo, DzStartBuyProbability1,  DzLookBackBars, Bars, i, 0.0001);
            if (DzStartBuyProbability2  > 0) bl2[i] = dzBuyP (ndo, DzStartBuyProbability2,  DzLookBackBars, Bars, i, 0.0001);
            if (DzStartSellProbability1 > 0) sl1[i] = dzSellP(ndo, DzStartSellProbability1, DzLookBackBars, Bars, i, 0.0001);
            if (DzStartSellProbability2 > 0) sl2[i] = dzSellP(ndo, DzStartSellProbability2, DzLookBackBars, Bars, i, 0.0001);
                                             zl1[i] = dzSellP(ndo, 0.5,                     DzLookBackBars, Bars, i, 0.0001);       
      
            setTrends(i,r);
            manageArrow(i,r);
              
    }
    for(i=limit; i>=0; i--)  ndma[i] = iMAOnArray(ndo,Bars,SigMaPeriod,0,Ma_Mode,i);
    manageAlerts();
    return(0);
    }
  
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (ArrayRange(trends,0)!=Bars) ArrayResize(trends,Bars);
    
      for (i = limit, r=Bars-i-1; i>=0; i--,r++)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            ndo[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothPhase,SmoothDouble,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,0,y);
            ndma[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothPhase,SmoothDouble,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,1,y);
            bl1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothPhase,SmoothDouble,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,2,y);
            bl2[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothPhase,SmoothDouble,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,3,y);
            sl1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothPhase,SmoothDouble,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,4,y);
            sl2[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothPhase,SmoothDouble,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,5,y);
            zl1[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",NdoPrice,EMAPeriod,SigMaPeriod,Ma_Mode,NormPeriod,SmoothPhase,SmoothDouble,DzLookBackBars,DzStartBuyProbability1,DzStartBuyProbability2,DzStartSellProbability1,DzStartSellProbability2,6,y);
  
            setTrends(i,r); 
            manageArrow(i,r);
            
            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  ndo[i+k]  = ndo[i]  + (ndo[i+n]  - ndo[i])  * k/n;
                  ndma[i+k] = ndma[i] + (ndma[i+n] - ndma[i]) * k/n;
                  bl1[i+k]  = bl1[i]  + (bl1[i+n]  - bl1[i])  * k/n;
                  bl2[i+k]  = bl2[i]  + (bl2[i+n]  - bl2[i])  * k/n;
                  sl1[i+k]  = sl1[i]  + (sl1[i+n]  - sl1[i])  * k/n;
                  sl2[i+k]  = sl2[i]  + (sl2[i+n]  - sl2[i])  * k/n;
                  zl1[i+k]  = zl1[i]  + (zl1[i+n]  - zl1[i])  * k/n;

               }  	            
   }
      
   manageAlerts();  
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}
      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//
//
//
//
//

void setTrends(int i, int r)
{
   trends[r][_tma1]  = trends[r-1][_tma1];
   trends[r][_tup1] = trends[r-1][_tup1];
   trends[r][_tup2] = trends[r-1][_tup2];
   trends[r][_tdn1] = trends[r-1][_tdn1];
   trends[r][_tdn2] = trends[r-1][_tdn2];
   trends[r][_tzl1] = trends[r-1][_tzl1];
   
      if (ndo[i] > ndma[i]) trends[r][_tma1] =  1;
      if (ndo[i] < ndma[i]) trends[r][_tma1] = -1;
      if (ndo[i] > bl1[i])  trends[r][_tup1] =  1;
      if (ndo[i] < bl1[i])  trends[r][_tup1] = -1;
      if (ndo[i] > bl2[i])  trends[r][_tup2] =  1;
      if (ndo[i] < bl2[i])  trends[r][_tup2] = -1;
      if (ndo[i] > sl1[i])  trends[r][_tdn1] =  1;
      if (ndo[i] < sl1[i])  trends[r][_tdn1] = -1;
      if (ndo[i] > sl2[i])  trends[r][_tdn2] =  1;
      if (ndo[i] < sl2[i])  trends[r][_tdn2] = -1;
      if (ndo[i] > zl1[i])  trends[r][_tzl1] =  1;
      if (ndo[i] < zl1[i])  trends[r][_tzl1] = -1;
      
      
      
}


//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 
                             whichBar = Bars-whichBar-1;

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnDevMaCross && trends[whichBar][_tma1] != trends[whichBar-1][_tma1])
      {
         if (trends[whichBar][_tma1] ==  1) doAlert(time1,mess1,whichBar,"Deviation and Ma Cross up");
         if (trends[whichBar][_tma1] == -1) doAlert(time1,mess1,whichBar,"Deviation and Ma Cross down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnUpLevel1Cross && trends[whichBar][_tup1] != trends[whichBar-1][_tup1])
      {
         if (trends[whichBar][_tup1] ==  1) doAlert(time2,mess2,whichBar,"crossed upper level 1 up");
         if (trends[whichBar][_tup1] == -1) doAlert(time2,mess2,whichBar,"crossed upper level 2 down");
      }
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnUpLevel2Cross && trends[whichBar][_tup2] != trends[whichBar-1][_tup2])
      {
         if (trends[whichBar][_tup2] ==  1) doAlert(time3,mess3,whichBar,"crossed upper level 2 up");
         if (trends[whichBar][_tup2] == -1) doAlert(time3,mess3,whichBar,"crossed upper level 2 down");
      }
      static datetime time4 = 0;
      static string   mess4 = "";
      if (alertsOnDnLevel1Cross && trends[whichBar][_tdn1] != trends[whichBar-1][_tdn1])
      {
         if (trends[whichBar][_tdn1] ==  1) doAlert(time4,mess4,whichBar,"crossed lower level 1 up");
         if (trends[whichBar][_tdn1] == -1) doAlert(time4,mess4,whichBar,"crossed lower level 1 down");
      }
      static datetime time5 = 0;
      static string   mess5 = "";
      if (alertsOnDnLevel2Cross && trends[whichBar][_tdn2] != trends[whichBar-1][_tdn2])
      {
         if (trends[whichBar][_tdn2] ==  1) doAlert(time5,mess5,whichBar,"crossed lower level 2 up");
         if (trends[whichBar][_tdn2] == -1) doAlert(time5,mess5,whichBar,"crossed lower level 2 down");
      }
      static datetime time6 = 0;
      static string   mess6 = "";
      if (alertsOnZeroLevelCross && trends[whichBar][_tzl1] != trends[whichBar-1][_tzl1])
      {
         if (trends[whichBar][_tzl1] ==  1) doAlert(time6,mess6,whichBar,"crossed zero level up");
         if (trends[whichBar][_tzl1] == -1) doAlert(time6,mess6,whichBar,"crossed Sell level down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS),"dz normalized deviation ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," dz normalized deviation "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i, int r)
{
   if (!calculateValue && arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (arrowsOnDevMaCross && trends[r][_tma1]!=trends[r-1][_tma1])
      {
         if (trends[r][_tma1] == 1)  drawArrow(i,arrowsUpColor,241,false);
         if (trends[r][_tma1] ==-1)  drawArrow(i,arrowsDnColor,242,true);
      }
      if (arrowsOnUpLevel1Cross && trends[r][_tup1]!=trends[r-1][_tup1])
      {
         if (trends[r][_tup1] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trends[r][_tup1] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
      if (arrowsOnUpLevel2Cross && trends[r][_tup2]!=trends[r-1][_tup2])
      {
         if (trends[r][_tup2] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trends[r][_tup2] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
      if (arrowsOnDnLevel1Cross  && trends[r][_tdn1]!=trends[r-1][_tdn1])
      {
         if (trends[r][_tdn1] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trends[r][_tdn1] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
      if (arrowsOnDnLevel2Cross  && trends[r][_tdn2]!=trends[r-1][_tdn2])
      {
         if (trends[r][_tdn2] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trends[r][_tdn2] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
      if (arrowsOnZeroLevelCross  && trends[r][_tzl1]!=trends[r-1][_tzl1])
      {
         if (trends[r][_tzl1] == 1) drawArrow(i,arrowsUpColor,241,false);
         if (trends[r][_tzl1] ==-1) drawArrow(i,arrowsDnColor,242,true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


